<style>
  .CarrierList {
    border-bottom: 1px dashed #eee;
    padding-bottom: 5px;
    margin-bottom: 5px;
  }

  .CarrierList span {
    display: inline-block;
    margin-right: 10px;
  }

</style>
<template>
  <div class="VehicleManagement">
    <div class="head-title">
      企业管理
      <div>
        <el-button @click="checkAll=false,dialogVisible = true" style="float: right; margin-top: -25px" size="small"
          type="primary">
          批量导出
        </el-button>
      </div>
      <div>
        <el-button type="primary" style="float: right; margin: -25px 10px 0px 0px" class="el-button--small"
          @click="CommonJump('firmEdit')">新增企业</el-button>
      </div>
    </div>
    <div class="content">
      <div>
        <div class="searchInput" style="width: 250px; margin-bottom: 10px">
          <el-input @keyup.enter.native="(msg.pageIndex = 1), getList()" @clear="(msg.pageIndex = 1), getList()"
            style="display: inline-block; width: 225px; height: 30px" :placeholder="`企业名称`" v-model="msg.Name"
            size="small" clearable>
          </el-input>
          <span @click="(msg.pageIndex = 1), getList()" class="el-icon-search" style="
              color: #979dad;
              font-size: 14px;
              position: relative;
              top: 1px;
            "></span>
        </div>
        <div class="searchInput" style="width: 200px; margin-bottom: 10px">
          <el-select size="small" v-model="msg.CategoryId" filterable @change="(msg.pageIndex = 1), getList()"
            :placeholder="`企业分类`">
            <el-option v-for="item in CategoryList" :key="item.ID" :label="item.ClassName" :value="item.ID">
            </el-option>
          </el-select>
        </div>
      </div>
      <el-table :data="tableData" v-loading="loading" border style="width: 100%; margin: 20px 0">
        <!-- <el-table-column prop="Id" label="ID" width="100">
          <template slot-scope="scope">
            <span @click="goRecruit(scope.row.ID)">{{ scope.row.ID }}</span>
          </template>
        </el-table-column> -->
        <el-table-column prop="Name" :label="`企业名称`" fixed="left" width="150"></el-table-column>
        <el-table-column prop="" label="封面" width="100">
          <template slot-scope="scope">
            <el-image v-if="scope.row.CoverImg" :src="scope.row.CoverImg" style="width: 50px"
              :preview-src-list="scope.row.LogoList">
            </el-image>
          </template>
        </el-table-column>
        <el-table-column prop="CategoryName" :label="`企业类别`" width="100"> </el-table-column>
        <el-table-column prop="Address" :label="`意向楼宇位置`" width="150"> </el-table-column>
        <el-table-column prop="ETypeName" :label="`意向楼宇等级`" width="150">
        </el-table-column>
        <el-table-column prop="OperationTime" :label="`投运时间`" width="120"> </el-table-column>
        <el-table-column prop="Renovation" :label="`楼宇装修`"> </el-table-column>
        <el-table-column prop="Payment" :label="`支付方式`" width="150"> </el-table-column>
        <el-table-column prop="HandoverDate" :label="`交房日期`" width="120"> </el-table-column>
        <el-table-column prop="IntentionalFloor" :label="`意向楼层`"> </el-table-column>
        <el-table-column prop="ElevatorNum" :label="`电梯数`"> </el-table-column>
        <el-table-column prop="PropertyFee" :label="`物业费(元)㎡/月`" width="150"> </el-table-column>
        <el-table-column prop="RentFee" :label="`月租金(元)㎡/月`" width="150"> </el-table-column>
        <el-table-column prop="" label="联系人" width="200">
          <template slot-scope="scope">
            <div>
              {{scope.row.ContactName}}
            </div>
            <div>
              {{scope.row.ContactPhone}}
            </div>
          </template>
        </el-table-column>
        <el-table-column fixed="right" label="操作" width="120" v-if="!readonly">
          <template slot-scope="scope">
            <el-tooltip class="item" effect="dark" content="编辑" placement="top">
              <img @click="CommonJump('firmEdit', { ID: scope.row.ServiceId })" src="../../assets/img/setup/edit.png"
                alt="" class="imgstyle" />
            </el-tooltip>
            <el-tooltip class="item" effect="dark" content="删除" placement="top">
              <img @click="delManage(scope.row)" src="../../assets/img/setup/del.png" alt="" class="imgstyle" />
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
      <el-pagination style="text-align: right" background @current-change="handleCurrentChange"
        :page-size="msg.pageSize" :current-page.sync="msg.pageIndex" layout="total,prev, pager, next" :total="total">
      </el-pagination>
    </div>

    <!-- 选择导出信息 -->
    <el-dialog title="选择导出信息" :visible.sync="dialogVisible" width="960px">
      <div v-loading="downLoadLoading" :element-loading-text="loadingText">
        <el-form style="border: 1px solid #f0f2f7" :model="addMsg" ref="addMsg" label-width="100px">
          <div style="
            box-sizing: border-box;
            background-color: #f3f5f6;
            width: 100%;
            padding-left: 20px;
            height: 50px;
            line-height: 50px;
          ">
            <el-checkbox :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange">全选
            </el-checkbox>
          </div>
          <div style="margin: 15px 0"></div>
          <div style="padding: 10px 25px 20px">
            <el-checkbox-group v-model="checkedCities" @change="handleCheckedCitiesChange">
              <el-checkbox style="margin-bottom: 10px; width: 135px" v-for="city in cities" :label="city.Id"
                :key="city.Name">
                {{ city.Name }}</el-checkbox>
            </el-checkbox-group>
          </div>
        </el-form>
        <div style="text-align: right; margin-top: 20px">
          <el-button size="small" type="primary" @click="downLoadCarrier">导出</el-button>
        </div>
      </div>
    </el-dialog>
  </div>
</template>
<script>
  import {
    setInterval,
    clearInterval
  } from 'timers';
  export default {
    data() {
      return {
        msg: {
          Name: "", //名称
          pageIndex: 1,
          pageSize: 15,
          CategoryId: 0, //楼宇等级
        },
        addMsg: {},
        dialogVisible: false,
        dateStr: [], //日期
        total: 0,
        tableData: [], //数据列表
        isShowAdd: false, //新增修改载体
        ProjectTypeList: [], //项目类型
        checkAll: false,
        checkedCities: [],
        cities: [],
        cityOptions: [],
        isIndeterminate: false,
        downLoadLoading: false, //导出Loading
        download_timer: null, //下载文件timer
        loadingText: "", //下载文件提示名称
        CategoryList: [],
        readonly: false,
      };
    },
    created() {
      if (this.$route.query && this.$route.query.readonly) {
        this.readonly = this.$route.query.readonly;
      }
      this.msg.BrandEnterpriseType = 2
      this.getList();
      this.getTypeEnumList();
      this.getDown();
    },
    watch: {
      $route: {
        handler(val, oldVal) {
          if (this.$route.query && this.$route.query.readonly) {
            this.readonly = this.$route.query.readonly;
          }
        },
        deep: true,
      },
    },
    methods: {
      getList() {
        this.loading = true;
        this.apipost("/api/YBTrade/GetEnterpriseServicesPage", this.msg, (res) => {
          this.loading = false;
          if (res.data.resultCode == 1) {
            this.total = res.data.data.count;
            let pageData = res.data.data.pageData;
            this.tableData = pageData;
            this.tableData.forEach((x) => {
              x.LogoList = [];
              x.LogoList.push(x.CoverImg);
            });
          }
        });
      },
      handleCheckAllChange(val) {
        this.checkedCities = val ? this.cityOptions : [];
        this.isIndeterminate = false;
      },
      handleCheckedCitiesChange(value) {
        let checkedCount = value.length;
        this.checkAll = checkedCount === this.cities.length;
        this.isIndeterminate =
          checkedCount > 0 && checkedCount < this.cities.length;
      },
      //下载载体文件
      downLoadCarrier() {
        this.msg.ExcelEnumIds = this.checkedCities;
        let msg = JSON.parse(JSON.stringify(this.msg));
        msg.RandomNum = Math.random();
        if (!msg.Id || msg.Id == "") {
          msg.Id = 0;
        }
        this.downLoadLoading = true;

        this.loadingText = "正在生成企业文件,请勿关闭或刷新页面...";

        var that = this;
        this.download_timer = setInterval(function () {
          that.checkCarrierFile(msg)
        }, 2000);
      },
      checkCarrierFile(msg) {
        var fileName = "企业信息.xls";
        var that = this;
        this.apipost(
          "/api/YBTrade/CheckEnterpriseServicesFile",
          msg,
          (res) => {
            if (res.data.resultCode == 1) {
              clearInterval(this.download_timer);
              this.checkedCities = [];
              this.loadingText = "正在下载企业文件,请勿关闭或刷新页面...";

              var fileUrl = res.data.data.fileUrl;
              var filepath = res.data.data.filePath;
              var key = res.data.message;
              var params = {
                fileUrl: fileUrl
              }
              //删除缓存和Key
              var deleteparams = {
                key: key,
                fileUrl: fileUrl,
                filepath: filepath,
              };
              var apiurl = that.domainManager().DomainUrl + "/api/Trade/GetFile";
              var postData = that.GetPostData("", params, "");
              that.$http.post(apiurl, postData, {
                responseType: 'arraybuffer',
                onDownloadProgress: (progressEvent) => {
                  const progress = Math.round((progressEvent.loaded / progressEvent.total) * 100);
                  that.loadingText = `正在下载【` + "企业" + `】文件` + progress +
                    `%,请勿关闭或刷新页面...`;
                  // 在这里处理下载进度, 如更新界面上的进度条
                }
              }).then((res) => {
                let blob = new Blob([res.data], {
                  type: "application/vnd.ms-excel"
                })
                let url = URL.createObjectURL(blob);
                let link = document.createElement('a');
                link.href = url;
                link.setAttribute("download", fileName);
                document.body.appendChild(link);
                link.click();
                that.downLoadLoading = false;
                that.loadingText = "";
                that.apipost("/api/Trade/DeleteKey", deleteparams, (res) => {})
                that.dialogVisible = false;
              }).catch(function (res) {
                console.log(res);
              });
            }
          }
        );
      },

      getDown() {
        this.cityOptions = [];
        this.apipost("/api/YBTrade/GetEnterpriseServicesExportEnumList", {}, (res) => {
          this.cities = res.data.data;
          let data = res.data.data;
          data.forEach((item) => {
            this.cityOptions.push(item.Id);
          });
        });
      },

      //删除
      delManage(obj) {
        let that = this;
        that.Confirm("是否删除?", function () {
          that.apipost(
            "/api/YBTrade/RemoveEnterpriseServicesInfo", {
              ServiceId: obj.ServiceId,
            },
            (res) => {
              if (res.data.resultCode == 1) {
                that.Success(res.data.message);
                that.getList();
              } else {
                that.Error(res.data.message);
              }
            }
          );
        });
      },
      handleCurrentChange(val) {
        this.msg.pageIndex = val;
        this.getList();
      },
      //获取项目类型
      getTypeEnumList() {
        this.apipost("/api/Trade/GetProjectTypeEnumList", {}, (res) => {
          if (res.data.resultCode == 1) {
            this.ProjectTypeList = res.data.data;
          }
        });
        this.apipost("/api/Trade/GetBrandClassList", {
          BrandCategory: 4
        }, (res) => {
          if (res.data.resultCode == 1) {
            this.CategoryList = res.data.data;
            let obj = {
              ClassName: "不限",
              ID: 0,
            };
            this.CategoryList.unshift(obj);
          }
        });
      },

      //获取项目类型
      getProject(type) {
        let str = "";
        this.ProjectTypeList.forEach((x) => {
          if (x.Id == type) {
            str = x.Name;
          }
        });
        return str;
      },
    },
    mounted() {},
  };

</script>
<style>
  .VehicleManagement .content .searchInput {
    border: 1px solid #dcdfe6;
    border-radius: 4px;
  }

  .VehicleManagement .content .searchInput .el-input__inner {
    border: none;
    outline: none;
    height: 30px;
    line-height: 30px;
  }

  .VehicleManagement .content .searchInput {
    line-height: normal;
    display: inline-table;
    width: 100%;
    border-collapse: separate;
    border-spacing: 0;
    width: 250px;
    margin-right: 20px;
  }

  .VehicleManagement .content {
    background: #fff;
    margin-top: 10px;
    padding: 20px;
    box-sizing: border-box;
  }

</style>
